diff -crN buildroot-2013.08.1-ckb-20140807-1/board/ckb/Config.in buildroot-2013.08.1-ckb-20141129-1/board/ckb/Config.in
*** buildroot-2013.08.1-ckb-20140807-1/board/ckb/Config.in	2014-07-08 19:25:34.000000000 +0900
--- buildroot-2013.08.1-ckb-20141129-1/board/ckb/Config.in	2014-11-26 09:12:54.000000000 +0900
***************
*** 231,236 ****
--- 231,242 ----
  	default y
  	help
  		This will build the sample application for EXT_CN CS1.
+ 
+ config BR2_CKB_WDT_SAMPLE
+ 	bool "WDT sample"
+ 	default y
+ 	help
+ 		This will build the sample application for Watchdog timer.
  endif
  
  if BR2_BOARD_CKB_RZ
diff -crN buildroot-2013.08.1-ckb-20140807-1/board/ckb/ckb-1808/before_packing_fs.sh buildroot-2013.08.1-ckb-20141129-1/board/ckb/ckb-1808/before_packing_fs.sh
*** buildroot-2013.08.1-ckb-20140807-1/board/ckb/ckb-1808/before_packing_fs.sh	1970-01-01 09:00:00.000000000 +0900
--- buildroot-2013.08.1-ckb-20141129-1/board/ckb/ckb-1808/before_packing_fs.sh	2014-02-13 09:03:05.000000000 +0900
***************
*** 0 ****
--- 1,14 ----
+ #!/bin/sh
+ #Environment variables; $TARGET_DIR is passed as the argument by buildroot
+ export TARGET_FS_FOLDER=$1
+ 
+ # legal-info licenses.txt
+ mkdir -p $TARGET_FS_FOLDER/etc/legal-info
+ cp $TARGET_FS_FOLDER/../legal-info/licenses.txt $TARGET_FS_FOLDER/etc/legal-info/licenses.txt
+ 
+ #Change permissions
+ chmod +x $TARGET_FS_FOLDER/etc/udhcpc.scripts 
+ chmod +x $TARGET_FS_FOLDER/etc/init.d/*
+ chmod +x $TARGET_FS_FOLDER/etc/network/wlan-scripts/*
+ #chmod +x $TARGET_FS_FOLDER/bin/*
+ sync
diff -crN buildroot-2013.08.1-ckb-20140807-1/board/ckb/ckb-1808/usr_to_rootfs.sh buildroot-2013.08.1-ckb-20141129-1/board/ckb/ckb-1808/usr_to_rootfs.sh
*** buildroot-2013.08.1-ckb-20140807-1/board/ckb/ckb-1808/usr_to_rootfs.sh	1970-01-01 09:00:00.000000000 +0900
--- buildroot-2013.08.1-ckb-20141129-1/board/ckb/ckb-1808/usr_to_rootfs.sh	2014-11-28 08:58:16.000000000 +0900
***************
*** 0 ****
--- 1,65 ----
+ #!/bin/sh
+ #Environment variables passed as the arguments by buildroot
+ # $1 : Root FS folder
+ # $2 : Folder to which /usr has been moved
+ 
+ export ROOT_FS_FOLDER=$1
+ export USR_FOLDER=$2
+ 
+ #copy important libs and bins from /usr directory to the root folder directory
+ 	mkdir -p $ROOT_FS_FOLDER/usr/bin
+ 	mkdir -p $ROOT_FS_FOLDER/usr/sbin
+ 	mkdir -p $ROOT_FS_FOLDER/usr/lib
+ 	mkdir -p $ROOT_FS_FOLDER/usr/local/bin
+ 	cp -rpd $USR_FOLDER/local/bin/* $ROOT_FS_FOLDER/usr/local/bin/
+ 	cp -rpd $USR_FOLDER/bin/iperf $ROOT_FS_FOLDER/usr/bin/
+ 	cp -rpd $USR_FOLDER/bin/ts_test $ROOT_FS_FOLDER/usr/bin/
+ 	cp -rpd $USR_FOLDER/bin/ntpdate $ROOT_FS_FOLDER/usr/bin/
+ 	cp -rpd $USR_FOLDER/bin/inotify* $ROOT_FS_FOLDER/usr/bin/
+ 	cp -rpd $USR_FOLDER/bin/i2c* $ROOT_FS_FOLDER/usr/bin/
+ 	cp -rpd $USR_FOLDER/lib/ts* $ROOT_FS_FOLDER/usr/lib/
+ 	cp -rpd $USR_FOLDER/lib/libts* $ROOT_FS_FOLDER/usr/lib
+ 	cp -rpd $USR_FOLDER/lib/libintl.* $ROOT_FS_FOLDER/usr/lib
+ 	cp -rpd $USR_FOLDER/lib/libnl* $ROOT_FS_FOLDER/usr/lib
+ 	cp -rpd $USR_FOLDER/lib/libssl* $ROOT_FS_FOLDER/usr/lib/
+ 	cp -rpd $USR_FOLDER/lib/libcrypto* $ROOT_FS_FOLDER/usr/lib/
+ 	cp -rpd $USR_FOLDER/lib/libgpg-error* $ROOT_FS_FOLDER/usr/lib/
+ 	cp -rpd $USR_FOLDER/lib/libdbus* $ROOT_FS_FOLDER/usr/lib/
+ 	cp -rpd $USR_FOLDER/lib/libstdc++.so* $ROOT_FS_FOLDER/usr/lib/
+ 	cp -rpd $USR_FOLDER/lib/crda $ROOT_FS_FOLDER/usr/lib/
+ 	cp -rpd $USR_FOLDER/lib/avahi $ROOT_FS_FOLDER/usr/lib/
+ 	cp -rpd $USR_FOLDER/lib/libavahi-* $ROOT_FS_FOLDER/usr/lib/
+ 	cp -rpd $USR_FOLDER/lib/libdaemon.* $ROOT_FS_FOLDER/usr/lib/
+ 	cp -rpd $USR_FOLDER/lib/libexpat.* $ROOT_FS_FOLDER/usr/lib/
+ 	cp -rpd $USR_FOLDER/lib/libgcrypt.* $ROOT_FS_FOLDER/usr/lib/
+ 	cp -rpd $USR_FOLDER/sbin/iw $ROOT_FS_FOLDER/usr/sbin/
+ 	cp -rpd $USR_FOLDER/sbin/wpa_* $ROOT_FS_FOLDER/usr/sbin/
+ 	cp -rpd $USR_FOLDER/sbin/hostapd $ROOT_FS_FOLDER/usr/sbin/
+ 	cp -rpd $USR_FOLDER/sbin/mtd* $ROOT_FS_FOLDER/usr/sbin/
+ 	cp -rpd $USR_FOLDER/sbin/rtc* $ROOT_FS_FOLDER/usr/sbin/
+ 	cp -rpd $USR_FOLDER/sbin/fbset* $ROOT_FS_FOLDER/usr/sbin/
+ 	cp -rpd $USR_FOLDER/sbin/avahi-* $ROOT_FS_FOLDER/usr/sbin/
+ 	cp -rpd $USR_FOLDER/share/avahi $ROOT_FS_FOLDER/usr/share/
+ 	cp -rpd $USR_FOLDER/sbin/fbset* $ROOT_FS_FOLDER/usr/sbin/
+ 	cp -rpd $USR_FOLDER/share/udhcpc $ROOT_FS_FOLDER/usr/share/
+ 	cp -rpd $USR_FOLDER/bin/_cside* $ROOT_FS_FOLDER/usr/bin/
+ 	cp -rpd $USR_FOLDER/bin/cside* $ROOT_FS_FOLDER/usr/bin/
+ 	cp -rpd $USR_FOLDER/bin/libcsidemprof.so $ROOT_FS_FOLDER/usr/bin/
+ 	cp -rpd $USR_FOLDER/lib/libcdbmem.so $ROOT_FS_FOLDER/lib/
+ # - IPTABLES
+ #	cp -rpd $USR_FOLDER/sbin/iptables* $ROOT_FS_FOLDER/usr/sbin/
+ #	cp -rpd $USR_FOLDER/sbin/xtables* $ROOT_FS_FOLDER/usr/sbin/
+ # - SDL
+ #	cp -rpd $USR_FOLDER/lib/libSDL* $ROOT_FS_FOLDER/usr/lib/
+ 	cp -rpd $USR_FOLDER/lib/libjpeg.so* $ROOT_FS_FOLDER/usr/lib/
+ #	cp -rpd $USR_FOLDER/lib/libtiff.so* $ROOT_FS_FOLDER/usr/lib/
+ #	cp -rpd $USR_FOLDER/lib/libz.so* $ROOT_FS_FOLDER/usr/lib/
+ #	cp -rpd $USR_FOLDER/lib/libfreetype.so* $ROOT_FS_FOLDER/usr/lib/
+ 
+ #End
+ 
+ #Change permissions
+ chmod +x $ROOT_FS_FOLDER/etc/udhcpc.scripts 
+ chmod +x $ROOT_FS_FOLDER/etc/init.d/*
+ chmod +x $ROOT_FS_FOLDER/etc/network/wlan-scripts/*
+ sync
diff -crN buildroot-2013.08.1-ckb-20140807-1/board/ckb/ckb-3352/before_packing_fs.sh buildroot-2013.08.1-ckb-20141129-1/board/ckb/ckb-3352/before_packing_fs.sh
*** buildroot-2013.08.1-ckb-20140807-1/board/ckb/ckb-3352/before_packing_fs.sh	1970-01-01 09:00:00.000000000 +0900
--- buildroot-2013.08.1-ckb-20141129-1/board/ckb/ckb-3352/before_packing_fs.sh	2014-02-12 17:58:35.000000000 +0900
***************
*** 0 ****
--- 1,14 ----
+ #!/bin/sh
+ #Environment variables; $TARGET_DIR is passed as the argument by buildroot
+ export TARGET_FS_FOLDER=$1
+ 
+ # legal-info licenses.txt
+ mkdir -p $TARGET_FS_FOLDER/etc/legal-info
+ cp $TARGET_FS_FOLDER/../legal-info/licenses.txt $TARGET_FS_FOLDER/etc/legal-info/licenses.txt
+ 
+ #Change permissions
+ chmod +x $TARGET_FS_FOLDER/etc/udhcpc.scripts 
+ chmod +x $TARGET_FS_FOLDER/etc/init.d/*
+ chmod +x $TARGET_FS_FOLDER/etc/network/wlan-scripts/*
+ #chmod +x $TARGET_FS_FOLDER/bin/*
+ sync
diff -crN buildroot-2013.08.1-ckb-20140807-1/board/ckb/ckb-3352/bootloader/device.c buildroot-2013.08.1-ckb-20141129-1/board/ckb/ckb-3352/bootloader/device.c
*** buildroot-2013.08.1-ckb-20140807-1/board/ckb/ckb-3352/bootloader/device.c	2014-06-16 14:45:09.000000000 +0900
--- buildroot-2013.08.1-ckb-20141129-1/board/ckb/ckb-3352/bootloader/device.c	2014-11-28 08:51:37.000000000 +0900
***************
*** 20,25 ****
--- 20,35 ----
  
  #include <defines.h>
  
+ int wait_for_bb(void);
+ int wait_for_pin(void);
+ void flush_fifo(void);
+ void enable_ddr3_clocks(void);
+ void config_vtp(void);
+ void phy_config_cmd(void);
+ void phy_config_data(void);
+ void config_emif_ddr3(void);
+ 
+ 
  #define Outport(a, addr, val)		((*(volatile unsigned long *)addr) = val)
  #define Inport(a, addr)				(*(volatile unsigned long *)addr)
  
***************
*** 201,209 ****
--- 211,221 ----
  
  /* MAIN PLL Fdll = 1 GHZ, */
  #define MPUPLL_M_275	 275	/* 125 * n */
+ #define MPUPLL_M_300	 300	/* 125 * n */
  #define MPUPLL_M_500	 500	/* 125 * n */
  #define MPUPLL_M_600	 600	/* 125 * n */
  #define MPUPLL_M_720	 720	/* 125 * n */
+ #define MPUPLL_M_800	 800	/* 125 * n */
  
  #define MPUPLL_N		 23	/* (n -1 ) */
  #define MPUPLL_M2		 1
***************
*** 253,258 ****
--- 265,271 ----
  #define DEFDCDC3			0x10
  #define DEFSLEW				0x11
  #define DCDC_GO				0x80
+ #define V0950				0x02
  #define V1100				0x08
  #define V1200				0x0C
  #define V1275				0x0F
***************
*** 570,575 ****
--- 583,591 ----
  #define vrefp			(PAD_CTRL_BASE + 0x330)
  #define vrefn			(PAD_CTRL_BASE + 0x334)
  
+ /* TI81XX spefic control submodules */
+ #define DEVICE_ID_REG_OFFSET		0x600
+ #define DEVICE_ID_REG	(CTRL_BASE + DEVICE_ID_REG_OFFSET)
  
  /* I2C */
  #define I2C_BASE1		0x44E0B000
***************
*** 664,671 ****
  	int clkmode;
  	int clksel;
  	int div_m2;
! 	int idlest_dpll_mpu;
! 
  	clkmode = Inport(3,CM_CLKMODE_DPLL_MPU) & ~0x7;			// 0x44E00488
  
  	/* Set the PLL to bypass Mode */
--- 680,686 ----
  	int clkmode;
  	int clksel;
  	int div_m2;
! 	
  	clkmode = Inport(3,CM_CLKMODE_DPLL_MPU) & ~0x7;			// 0x44E00488
  
  	/* Set the PLL to bypass Mode */
***************
*** 1134,1147 ****
  }
  
  
! gpio1_config()
  {
  	/* NOR bank config */ 
  	Outport(3,GPIO1_SYSCONFIG,	IDLEMODE | SOFTRESET | AUTOIDLE );						// 0x4804C010
  	Outport(3,GPIO1_OE, Inport(3,GPIO1_OE) & (~(0x7f<<20)));								// 0x4804C134
  }
  
! config_am335x_ddr3(void)
  {
  
  	int DDR3_IOCTRL_VALUE		= 0x18B;
--- 1149,1162 ----
  }
  
  
! void gpio1_config()
  {
  	/* NOR bank config */ 
  	Outport(3,GPIO1_SYSCONFIG,	IDLEMODE | SOFTRESET | AUTOIDLE );						// 0x4804C010
  	Outport(3,GPIO1_OE, Inport(3,GPIO1_OE) & (~(0x7f<<20)));								// 0x4804C134
  }
  
! void config_am335x_ddr3(void)
  {
  
  	int DDR3_IOCTRL_VALUE		= 0x18B;
***************
*** 1172,1178 ****
  	config_emif_ddr3();
  }
  
! enable_ddr3_clocks(void)
  {
  	/* Enable the  EMIF_FW Functional clock */
  	Outport(3, CM_PER_EMIF_FW_CLKCTRL,PRCM_MOD_EN);
--- 1187,1193 ----
  	config_emif_ddr3();
  }
  
! void enable_ddr3_clocks(void)
  {
  	/* Enable the  EMIF_FW Functional clock */
  	Outport(3, CM_PER_EMIF_FW_CLKCTRL,PRCM_MOD_EN);
***************
*** 1182,1188 ****
  	while ((Inport(3,CM_PER_EMIF_CLKCTRL)) != PRCM_MOD_EN);
  }
  
! phy_config_cmd(void)
  {
  	int DDR3_RATIO				= 0x40;
  	int DDR3_INVERT_CLKOUT		= 0x1;
--- 1197,1203 ----
  	while ((Inport(3,CM_PER_EMIF_CLKCTRL)) != PRCM_MOD_EN);
  }
  
! void phy_config_cmd(void)
  {
  	int DDR3_RATIO				= 0x40;
  	int DDR3_INVERT_CLKOUT		= 0x1;
***************
*** 1195,1201 ****
  	Outport(3, CMD2_INVERT_CLKOUT_0,	DDR3_INVERT_CLKOUT);
  }
  
! phy_config_data(void)
  {
  	int DDR3_RD_DQS				= 0x3B;
  	int DDR3_WR_DQS				= 0x85;
--- 1210,1216 ----
  	Outport(3, CMD2_INVERT_CLKOUT_0,	DDR3_INVERT_CLKOUT);
  }
  
! void phy_config_data(void)
  {
  	int DDR3_RD_DQS				= 0x3B;
  	int DDR3_WR_DQS				= 0x85;
***************
*** 1213,1219 ****
  	Outport(3, DATA1_WR_DATA_SLAVE_RATIO_0,	DDR3_PHY_WR_DATA);
  }
  
! config_emif_ddr3(void)
  {
  
  	int DDR3_EMIF_READ_LATENCY		= 0x06;				// RD_Latency = (CL + 2) - 1
--- 1228,1234 ----
  	Outport(3, DATA1_WR_DATA_SLAVE_RATIO_0,	DDR3_PHY_WR_DATA);
  }
  
! void config_emif_ddr3(void)
  {
  
  	int DDR3_EMIF_READ_LATENCY		= 0x06;				// RD_Latency = (CL + 2) - 1
***************
*** 1222,1229 ****
  	int DDR3_EMIF_TIM3				= 0x501F830F;		// by calc_tool
  	int DDR3_EMIF_SDREF				= 0x0000093B;		// 303MHz * 7.8us
  	int DDR3_ZQ_CFG					= 0x50074BE4;
! 	int DDR3_EMIF_SDCFG				= 0x61C04AB2;
! 
  	int reg_sdram_type;
  	int reg_ibank_pos;
  	int reg_ddr_term;
--- 1237,1243 ----
  	int DDR3_EMIF_TIM3				= 0x501F830F;		// by calc_tool
  	int DDR3_EMIF_SDREF				= 0x0000093B;		// 303MHz * 7.8us
  	int DDR3_ZQ_CFG					= 0x50074BE4;
! 	
  	int reg_sdram_type;
  	int reg_ibank_pos;
  	int reg_ddr_term;
***************
*** 1271,1277 ****
  	reg_ebank				= (0<<3);
  	reg_pagesize			= (2);			/* 10 1k */
  
- //	Outport(3, EMIF4_0_SDRAM_CONFIG,			DDR3_EMIF_SDCFG);
  	Outport(3, EMIF4_0_SDRAM_CONFIG,	reg_sdram_type		|
                                          reg_ibank_pos		|
                                          reg_ddr_term		|
--- 1285,1290 ----
***************
*** 1290,1298 ****
  }
  
  
! void pll_init()
  {
! 	mpu_pll_config(MPUPLL_M_500);
  	core_pll_config();
  	per_pll_config();
  	ddr_pll_config();
--- 1303,1314 ----
  }
  
  
! void pll_init(int revision)
  {
! 	if(revision >= AM335X_REV_ES2_0)
! 		mpu_pll_config(MPUPLL_M_600);
! 	else
! 		mpu_pll_config(MPUPLL_M_500);
  	core_pll_config();
  	per_pll_config();
  	ddr_pll_config();
***************
*** 1301,1307 ****
  	per_clocks_enable();						/* Enable the required peripherals */
  }
  
! config_vtp(void)
  {
  	int VTP0_CTRL_REG;
  	int vtp_ctrl	= 0xE0C;
--- 1317,1323 ----
  	per_clocks_enable();						/* Enable the required peripherals */
  }
  
! void config_vtp(void)
  {
  	int VTP0_CTRL_REG;
  	int vtp_ctrl	= 0xE0C;
***************
*** 1329,1335 ****
   ***  I2C
   ******************************************************************************** */
  
! i2c_init(int speed, int slaveadd)
  {
  	int psc;
  	int fsscll;
--- 1345,1351 ----
   ***  I2C
   ******************************************************************************** */
  
! void i2c_init(int speed, int slaveadd)
  {
  	int psc;
  	int fsscll;
***************
*** 1340,1346 ****
  	int sclh;
  	int timeout;
  
! 	int I2C_PSC_MAX		= 0x0f;
  	int I2C_PSC_MIN		= 0x00;
  
  	int I2C_IP_CLK		= 48000000;
--- 1356,1362 ----
  	int sclh;
  	int timeout;
  
! 	//int I2C_PSC_MAX		= 0x0f;
  	int I2C_PSC_MIN		= 0x00;
  
  	int I2C_IP_CLK		= 48000000;
***************
*** 1529,1535 ****
  	return i2c_error;
  }
  
! flush_fifo(void)
  {	int stat;
  
  	/* note: if you try and read data when its not there or ready
--- 1545,1551 ----
  	return i2c_error;
  }
  
! void flush_fifo(void)
  {	int stat;
  
  	/* note: if you try and read data when its not there or ready
***************
*** 1742,1749 ****
--- 1758,1767 ----
  	}
  
  	if (timeout <= 0) {
+ 		return 1;
  	}
  	Outport(3,I2C_STAT,0xFFFF);	 /* clear delayed stuff*/
+ 	return 0;
  }
  
  /**************************************************************************************/
***************
*** 1769,1775 ****
  	return status;
  }
  
! udelay(int dly)
  {
  	int i;
  	for(i=0;i<10000;i++);
--- 1787,1793 ----
  	return status;
  }
  
! void udelay(int dly)
  {
  	int i;
  	for(i=0;i<10000;i++);
***************
*** 1792,1830 ****
  int tps65217_reg_write(int prot_level, int dest_reg, int dest_val, int mask)
  {
  
! 		int read_val;
! 		int xor_reg;
! 
! 		/* if we are affecting only a bit field, read dest_reg and apply the mask */
! 		if (mask != MASK_ALL_BITS) {
! 			if (i2c_read_byte(TPS65217_CHIP_PM, dest_reg, &read_val))
! 				return 1;
! 			read_val &= (~mask);
! 			read_val |= (dest_val & mask);
! 			dest_val = read_val;
! 		}
  
! 		if (prot_level > 0) {
! 			xor_reg = dest_reg ^ PASSWORD_UNLOCK;
! 			if (i2c_write_byte(TPS65217_CHIP_PM, PASSWORD, xor_reg))
! 				return 1;
! 		}
  
! 		if (i2c_write_byte(TPS65217_CHIP_PM, dest_reg, dest_val))
  			return 1;
  
! 		if (prot_level == PROT_LEVEL_2) {
! 			if (i2c_write_byte(TPS65217_CHIP_PM, PASSWORD, xor_reg))
! 				return 1;
  
! 			if (i2c_write_byte(TPS65217_CHIP_PM, dest_reg, dest_val))
! 				return 1;
! 		}
  
! 		return 0;
  }
  
! arm_275m()
  {
  	int mask1	= 0x3F;
  	int mask2	= 0x80;;
--- 1810,1848 ----
  int tps65217_reg_write(int prot_level, int dest_reg, int dest_val, int mask)
  {
  
! 	int read_val;
! 	int xor_reg;
  
! 	/* if we are affecting only a bit field, read dest_reg and apply the mask */
! 	if (mask != MASK_ALL_BITS) {
! 		if (i2c_read_byte(TPS65217_CHIP_PM, dest_reg, &read_val))
! 			return 1;
! 		read_val &= (~mask);
! 		read_val |= (dest_val & mask);
! 		dest_val = read_val;
! 	}
  
! 	if (prot_level > 0) {
! 		xor_reg = dest_reg ^ PASSWORD_UNLOCK;
! 		if (i2c_write_byte(TPS65217_CHIP_PM, PASSWORD, xor_reg))
  			return 1;
+ 	}
  
! 	if (i2c_write_byte(TPS65217_CHIP_PM, dest_reg, dest_val))
! 		return 1;
  
! 	if (prot_level == PROT_LEVEL_2) {
! 		if (i2c_write_byte(TPS65217_CHIP_PM, PASSWORD, xor_reg))
! 			return 1;
  
! 		if (i2c_write_byte(TPS65217_CHIP_PM, dest_reg, dest_val))
! 			return 1;
! 	}
! 	return 0;
  }
  
! // Rev ES1
! void arm_275m()
  {
  	int mask1	= 0x3F;
  	int mask2	= 0x80;;
***************
*** 1836,1842 ****
  	mpu_pll_config(MPUPLL_M_275);
  
  }
! arm_500m()
  {
  	int mask1	= 0x3F;
  	int mask2	= 0x80;;
--- 1854,1877 ----
  	mpu_pll_config(MPUPLL_M_275);
  
  }
! 
! // Rev >= ES2_0
! void arm_300m()
! {
! 	int mask1	= 0x3F;
! 	int mask2	= 0x80;;
! 
! 	i2c_init(100000,1);
! 	//tps65217_reg_write(PROT_LEVEL_2,DEFDCDC2,V1100,mask1);
! 	tps65217_reg_write(PROT_LEVEL_2,DEFDCDC2,V0950,mask1);
! 	tps65217_reg_write(PROT_LEVEL_2,DEFSLEW,DCDC_GO,mask2);
! 	udelay(1);
! 	mpu_pll_config(MPUPLL_M_300);
! 
! }
! 
! // Rev ES1
! void arm_500m()
  {
  	int mask1	= 0x3F;
  	int mask2	= 0x80;;
***************
*** 1849,1886 ****
  
  }
  
! arm_600m()
  {
  	int mask1	= 0x3F;
  	int mask2	= 0x80;;
  
  	i2c_init(100000,1);
! 	tps65217_reg_write(PROT_LEVEL_2,DEFDCDC2,V1200,mask1);
  	tps65217_reg_write(PROT_LEVEL_2,DEFSLEW,DCDC_GO,mask2);
  	udelay(1);
  	mpu_pll_config(MPUPLL_M_600);
  
  }
  
! arm_720m()
  {
  	int mask1	= 0x3F;
  	int mask2	= 0x80;;
  
  	i2c_init(100000,1);
! 	tps65217_reg_write(PROT_LEVEL_2,DEFDCDC2,V1275,mask1);
  	tps65217_reg_write(PROT_LEVEL_2,DEFSLEW,DCDC_GO,mask2);
  	udelay(1);
  	mpu_pll_config(MPUPLL_M_720);
  
  }
  
  
  
! void init_DEVICE()
  {
  	watchdog_init();
! 	pll_init();
  	
  	pin_config();
  	gpmc_config();
--- 1884,1965 ----
  
  }
  
! void arm_600m(int revision)
  {
  	int mask1	= 0x3F;
  	int mask2	= 0x80;;
  
  	i2c_init(100000,1);
! 	if(revision >= AM335X_REV_ES2_0)
! 		tps65217_reg_write(PROT_LEVEL_2,DEFDCDC2,V1100,mask1);
! 	else
! 		tps65217_reg_write(PROT_LEVEL_2,DEFDCDC2,V1200,mask1);
  	tps65217_reg_write(PROT_LEVEL_2,DEFSLEW,DCDC_GO,mask2);
  	udelay(1);
  	mpu_pll_config(MPUPLL_M_600);
  
  }
  
! void arm_720m(int revision)
  {
  	int mask1	= 0x3F;
  	int mask2	= 0x80;;
  
  	i2c_init(100000,1);
! 	if(revision >= AM335X_REV_ES2_0)
! 		tps65217_reg_write(PROT_LEVEL_2,DEFDCDC2,V1200,mask1);
! 	else
! 		tps65217_reg_write(PROT_LEVEL_2,DEFDCDC2,V1275,mask1);
  	tps65217_reg_write(PROT_LEVEL_2,DEFSLEW,DCDC_GO,mask2);
  	udelay(1);
  	mpu_pll_config(MPUPLL_M_720);
  
  }
+ // Rev >= ES2_0
+ void arm_800m()
+ {
+ 	int mask1	= 0x3F;
+ 	int mask2	= 0x80;;
+ 
+ 	i2c_init(100000,1);
+ 	tps65217_reg_write(PROT_LEVEL_2,DEFDCDC2,V1275,mask1);
+ 	tps65217_reg_write(PROT_LEVEL_2,DEFSLEW,DCDC_GO,mask2);
+ 	udelay(1);
+ 	mpu_pll_config(MPUPLL_M_800);
  
+ }
  
+ unsigned long get_dev_id()
+ {
+ 	return Inport(3, DEVICE_ID_REG);
+ }
  
! int init_DEVICE()
  {
+ 	int revision;
+ 	unsigned long idcode;
+ 	unsigned char rev;
+ 
  	watchdog_init();
! 	/* get the CPU revision */
! 	idcode = get_dev_id();
! 	rev = (idcode >> 28) & 0xff;
! 	switch(rev)
! 	{
! 	case 0:
! 		revision = AM335X_REV_ES1_0;
! 		break;
! 	case 1:
! 		revision = AM335X_REV_ES2_0;
! 		break;
! 	case 2:
! 		revision = AM335X_REV_ES2_1;
! 		break;
! 	default:
! 		revision = AM335X_REV_UNKNOWN;
! 		break;
! 	}
! 	pll_init(revision);
  	
  	pin_config();
  	gpmc_config();
***************
*** 1888,1894 ****
  	config_am335x_ddr3();
  	/* some problem with CS1 mode, use GPIO mode */
  	gpmc_cs1_ext_cn_config(1);			/* 1 -> GPIO mode, 0->CS1 mode */
! 
  }
  
  void set_flash_bank(int bank)
--- 1967,1977 ----
  	config_am335x_ddr3();
  	/* some problem with CS1 mode, use GPIO mode */
  	gpmc_cs1_ext_cn_config(1);			/* 1 -> GPIO mode, 0->CS1 mode */
! 	if(revision >= AM335X_REV_ES2_0)
! 		arm_800m();
! 	else
! 		arm_720m(revision);
! 	return revision;
  }
  
  void set_flash_bank(int bank)
diff -crN buildroot-2013.08.1-ckb-20140807-1/board/ckb/ckb-3352/bootloader/include/device.h buildroot-2013.08.1-ckb-20141129-1/board/ckb/ckb-3352/bootloader/include/device.h
*** buildroot-2013.08.1-ckb-20140807-1/board/ckb/ckb-3352/bootloader/include/device.h	2014-06-16 14:43:24.000000000 +0900
--- buildroot-2013.08.1-ckb-20141129-1/board/ckb/ckb-3352/bootloader/include/device.h	2014-11-28 08:50:39.000000000 +0900
***************
*** 25,30 ****
--- 25,37 ----
  #endif
  
  #define TARGET_NAME	"CKB-3352 (COMPUTEX Kumikomi Board)"
+ // CPU Revision
+ enum {
+ 	AM335X_REV_ES1_0,
+ 	AM335X_REV_ES2_0,
+ 	AM335X_REV_ES2_1,
+ 	AM335X_REV_UNKNOWN
+ };
  
  // System Control Module register structure
  typedef struct _DEVICE_SYS_MODULE_REGS_
***************
*** 495,600 ****
  #define dlm ier
  #define LSR lsr
  
! /* useful defaults for LCR */
  #define UART_LCR_8N1	0x03
! 
  #define UART_RESET		(0x1 << 1)
  #define UART_CLK_RUNNING_MASK	0x1
! #define UART_SMART_IDLE_EN	(0x1 << 0x3)
! 
! /*
!  * These are the definitions for the FIFO Control Register
!  */
! #define UART_FCR_FIFO_EN	0x01 /* Fifo enable */
! #define UART_FCR_CLEAR_RCVR	0x02 /* Clear the RCVR FIFO */
! #define UART_FCR_CLEAR_XMIT	0x04 /* Clear the XMIT FIFO */
! #define UART_FCR_DMA_SELECT	0x08 /* For DMA applications */
! #define UART_FCR_TRIGGER_MASK	0xC0 /* Mask for the FIFO trigger range */
! #define UART_FCR_TRIGGER_1	0x00 /* Mask for trigger set at 1 */
! #define UART_FCR_TRIGGER_4	0x40 /* Mask for trigger set at 4 */
! #define UART_FCR_TRIGGER_8	0x80 /* Mask for trigger set at 8 */
! #define UART_FCR_TRIGGER_14	0xC0 /* Mask for trigger set at 14 */
! 
! #define UART_FCR_RXSR		0x02 /* Receiver soft reset */
! #define UART_FCR_TXSR		0x04 /* Transmitter soft reset */
! 
! /*
!  * These are the definitions for the Modem Control Register
!  */
! #define UART_MCR_DTR	0x01		/* DTR   */
! #define UART_MCR_RTS	0x02		/* RTS   */
! #define UART_MCR_OUT1	0x04		/* Out 1 */
! #define UART_MCR_OUT2	0x08		/* Out 2 */
! #define UART_MCR_LOOP	0x10		/* Enable loopback test mode */
! 
! #define UART_MCR_DMA_EN	0x04
! #define UART_MCR_TX_DFR	0x08
! 
! /*
!  * These are the definitions for the Line Control Register
!  *
!  * Note: if the word length is 5 bits (UART_LCR_WLEN5), then setting
!  * UART_LCR_STOP will select 1.5 stop bits, not 2 stop bits.
!  */
! #define UART_LCR_WLS_MSK 0x03		/* character length select mask */
! #define UART_LCR_WLS_5	0x00		/* 5 bit character length */
! #define UART_LCR_WLS_6	0x01		/* 6 bit character length */
! #define UART_LCR_WLS_7	0x02		/* 7 bit character length */
! #define UART_LCR_WLS_8	0x03		/* 8 bit character length */
! #define UART_LCR_STB	0x04		/* # stop Bits, off=1, on=1.5 or 2) */
! #define UART_LCR_PEN	0x08		/* Parity eneble */
! #define UART_LCR_EPS	0x10		/* Even Parity Select */
! #define UART_LCR_STKP	0x20		/* Stick Parity */
! #define UART_LCR_SBRK	0x40		/* Set Break */
! #define UART_LCR_BKSE	0x80		/* Bank select enable */
! #define UART_LCR_DLAB	0x80		/* Divisor latch access bit */
! 
! /*
!  * These are the definitions for the Line Status Register
!  */
! #define UART_LSR_DR	0x01		/* Data ready */
! #define UART_LSR_OE	0x02		/* Overrun */
! #define UART_LSR_PE	0x04		/* Parity error */
! #define UART_LSR_FE	0x08		/* Framing error */
! #define UART_LSR_BI	0x10		/* Break */
! #define UART_LSR_THRE	0x20		/* Xmit holding register empty */
! #define UART_LSR_TEMT	0x40		/* Xmitter empty */
! #define UART_LSR_ERR	0x80		/* Error */
! 
! #define UART_MSR_DCD	0x80		/* Data Carrier Detect */
! #define UART_MSR_RI	0x40		/* Ring Indicator */
! #define UART_MSR_DSR	0x20		/* Data Set Ready */
! #define UART_MSR_CTS	0x10		/* Clear to Send */
! #define UART_MSR_DDCD	0x08		/* Delta DCD */
! #define UART_MSR_TERI	0x04		/* Trailing edge ring indicator */
! #define UART_MSR_DDSR	0x02		/* Delta DSR */
! #define UART_MSR_DCTS	0x01		/* Delta CTS */
! 
! /*
!  * These are the definitions for the Interrupt Identification Register
!  */
! #define UART_IIR_NO_INT	0x01	/* No interrupts pending */
! #define UART_IIR_ID	0x06	/* Mask for the interrupt ID */
! 
! #define UART_IIR_MSI	0x00	/* Modem status interrupt */
! #define UART_IIR_THRI	0x02	/* Transmitter holding register empty */
! #define UART_IIR_RDI	0x04	/* Receiver data interrupt */
! #define UART_IIR_RLSI	0x06	/* Receiver line status interrupt */
! 
! /*
!  * These are the definitions for the Interrupt Enable Register
!  */
! #define UART_IER_MSI	0x08	/* Enable Modem status interrupt */
! #define UART_IER_RLSI	0x04	/* Enable receiver line status interrupt */
! #define UART_IER_THRI	0x02	/* Enable Transmitter holding register int. */
! #define UART_IER_RDI	0x01	/* Enable receiver data interrupt */
! 
! #define UART_LCRVAL UART_LCR_8N1		/* 8 data, 1 stop, no parity */
! #define UART_MCRVAL (UART_MCR_DTR | \
! 		     UART_MCR_RTS)		/* RTS/DTR */
! #define UART_FCRVAL (UART_FCR_FIFO_EN |	\
! 		     UART_FCR_RXSR |	\
! 		     UART_FCR_TXSR)		/* Clear & enable FIFOs */
  
  
  // GPIO Register structures
--- 502,607 ----
  #define dlm ier
  #define LSR lsr
  
! /* useful defaults for LCR */
  #define UART_LCR_8N1	0x03
! 
  #define UART_RESET		(0x1 << 1)
  #define UART_CLK_RUNNING_MASK	0x1
! #define UART_SMART_IDLE_EN	(0x1 << 0x3)
! 
! /*
!  * These are the definitions for the FIFO Control Register
!  */
! #define UART_FCR_FIFO_EN	0x01 /* Fifo enable */
! #define UART_FCR_CLEAR_RCVR	0x02 /* Clear the RCVR FIFO */
! #define UART_FCR_CLEAR_XMIT	0x04 /* Clear the XMIT FIFO */
! #define UART_FCR_DMA_SELECT	0x08 /* For DMA applications */
! #define UART_FCR_TRIGGER_MASK	0xC0 /* Mask for the FIFO trigger range */
! #define UART_FCR_TRIGGER_1	0x00 /* Mask for trigger set at 1 */
! #define UART_FCR_TRIGGER_4	0x40 /* Mask for trigger set at 4 */
! #define UART_FCR_TRIGGER_8	0x80 /* Mask for trigger set at 8 */
! #define UART_FCR_TRIGGER_14	0xC0 /* Mask for trigger set at 14 */
! 
! #define UART_FCR_RXSR		0x02 /* Receiver soft reset */
! #define UART_FCR_TXSR		0x04 /* Transmitter soft reset */
! 
! /*
!  * These are the definitions for the Modem Control Register
!  */
! #define UART_MCR_DTR	0x01		/* DTR   */
! #define UART_MCR_RTS	0x02		/* RTS   */
! #define UART_MCR_OUT1	0x04		/* Out 1 */
! #define UART_MCR_OUT2	0x08		/* Out 2 */
! #define UART_MCR_LOOP	0x10		/* Enable loopback test mode */
! 
! #define UART_MCR_DMA_EN	0x04
! #define UART_MCR_TX_DFR	0x08
! 
! /*
!  * These are the definitions for the Line Control Register
!  *
!  * Note: if the word length is 5 bits (UART_LCR_WLEN5), then setting
!  * UART_LCR_STOP will select 1.5 stop bits, not 2 stop bits.
!  */
! #define UART_LCR_WLS_MSK 0x03		/* character length select mask */
! #define UART_LCR_WLS_5	0x00		/* 5 bit character length */
! #define UART_LCR_WLS_6	0x01		/* 6 bit character length */
! #define UART_LCR_WLS_7	0x02		/* 7 bit character length */
! #define UART_LCR_WLS_8	0x03		/* 8 bit character length */
! #define UART_LCR_STB	0x04		/* # stop Bits, off=1, on=1.5 or 2) */
! #define UART_LCR_PEN	0x08		/* Parity eneble */
! #define UART_LCR_EPS	0x10		/* Even Parity Select */
! #define UART_LCR_STKP	0x20		/* Stick Parity */
! #define UART_LCR_SBRK	0x40		/* Set Break */
! #define UART_LCR_BKSE	0x80		/* Bank select enable */
! #define UART_LCR_DLAB	0x80		/* Divisor latch access bit */
! 
! /*
!  * These are the definitions for the Line Status Register
!  */
! #define UART_LSR_DR	0x01		/* Data ready */
! #define UART_LSR_OE	0x02		/* Overrun */
! #define UART_LSR_PE	0x04		/* Parity error */
! #define UART_LSR_FE	0x08		/* Framing error */
! #define UART_LSR_BI	0x10		/* Break */
! #define UART_LSR_THRE	0x20		/* Xmit holding register empty */
! #define UART_LSR_TEMT	0x40		/* Xmitter empty */
! #define UART_LSR_ERR	0x80		/* Error */
! 
! #define UART_MSR_DCD	0x80		/* Data Carrier Detect */
! #define UART_MSR_RI	0x40		/* Ring Indicator */
! #define UART_MSR_DSR	0x20		/* Data Set Ready */
! #define UART_MSR_CTS	0x10		/* Clear to Send */
! #define UART_MSR_DDCD	0x08		/* Delta DCD */
! #define UART_MSR_TERI	0x04		/* Trailing edge ring indicator */
! #define UART_MSR_DDSR	0x02		/* Delta DSR */
! #define UART_MSR_DCTS	0x01		/* Delta CTS */
! 
! /*
!  * These are the definitions for the Interrupt Identification Register
!  */
! #define UART_IIR_NO_INT	0x01	/* No interrupts pending */
! #define UART_IIR_ID	0x06	/* Mask for the interrupt ID */
! 
! #define UART_IIR_MSI	0x00	/* Modem status interrupt */
! #define UART_IIR_THRI	0x02	/* Transmitter holding register empty */
! #define UART_IIR_RDI	0x04	/* Receiver data interrupt */
! #define UART_IIR_RLSI	0x06	/* Receiver line status interrupt */
! 
! /*
!  * These are the definitions for the Interrupt Enable Register
!  */
! #define UART_IER_MSI	0x08	/* Enable Modem status interrupt */
! #define UART_IER_RLSI	0x04	/* Enable receiver line status interrupt */
! #define UART_IER_THRI	0x02	/* Enable Transmitter holding register int. */
! #define UART_IER_RDI	0x01	/* Enable receiver data interrupt */
! 
! #define UART_LCRVAL UART_LCR_8N1		/* 8 data, 1 stop, no parity */
! #define UART_MCRVAL (UART_MCR_DTR | \
! 		     UART_MCR_RTS)		/* RTS/DTR */
! #define UART_FCRVAL (UART_FCR_FIFO_EN |	\
! 		     UART_FCR_RXSR |	\
! 		     UART_FCR_TXSR)		/* Clear & enable FIFOs */
  
  
  // GPIO Register structures
***************
*** 630,636 ****
  * Global Function Declarations                             *
  ***********************************************************/
  // System Initialization prototypes
! extern void  init_DEVICE(void);
  
  // Peripheral Initialization prototypes
  extern Uint32  DEVICE_UARTInit(int baudrate);
--- 637,643 ----
  * Global Function Declarations                             *
  ***********************************************************/
  // System Initialization prototypes
! extern int init_DEVICE(void);
  
  // Peripheral Initialization prototypes
  extern Uint32  DEVICE_UARTInit(int baudrate);
